"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var vue_1 = tslib_1.__importDefault(require("vue"));
var lodash_clonedeep_1 = tslib_1.__importDefault(require("lodash.clonedeep"));
var diff_1 = require("./diff");
var devtool_1 = require("./devtool");
var createReduxStore_1 = require("../core/utils/createReduxStore");
var changed = [];
var unsubscribe;
exports.reducerChanged = function (reducerName, value) {
    changed.push([reducerName, value]);
};
exports.createReduxStore = function (config) {
    var store = createReduxStore_1.createReduxStore(config);
    var originalState = store.getState();
    var vm = new vue_1.default({
        data: {
            state: lodash_clonedeep_1.default(originalState),
        },
    });
    devtool_1.devtoolPlugin(store);
    if (unsubscribe) {
        unsubscribe();
    }
    // The first subscription from store
    unsubscribe = store.subscribe(function () {
        var currentState = store.getState();
        if (currentState !== originalState) {
            diff_1.applyPatch(originalState, currentState, vm.state);
            originalState = currentState;
        }
    });
    return store;
};
